void par_nepar(int a[], n)
{
        /* Polje preuredjujemo modificiranom varijantom sortiranja izborom
           ekstrema. Najmanji parni iz nesredjenog dijela polja ide na
           pocetak, a najmanji neparni ide na kraj nesredjenog dijela polja.
           Varijable i_par, i_nepar pamte pripadne pozicije na koje treba
           dovesti te elemente (pocetak i kraj nesredjenog dijela polja). */

    int i_par = 0, i_nepar = n-1;
    int i_min_par, i_min_nepar;    /* Indeksi najmanjeg parnog, neparnog. */
    int i, temp;

        /* Nesredjeni dio polja je a[i_par], ..., a[i_nepar].
           Vanjska petlja se vrti sve dok je i_par < i_nepar.
           Moze i ako su jednaki, ali nije potrebno, jer ne trazimo tocan
           broj parnih, odnosno, neparnih u polju. */
    while (i_par < i_nepar) {
            /* Indekse najmanjeg parnog, odnosno, najmanjeg neparnog elementa
               inicijaliziramo na -1, kao signal da takvih elemenata vise
               ne mora biti u nesredjenom dijelu polja. */
        i_min_par = -1;
        i_min_nepar = -1;

            /* Prolaz kroz nesredjeni dio polja. */
        for (i = i_par; i <= i_nepar; ++i)
                /* Ovisno o parnosti elementa a[i], provjeri je li on novi
                   najmanji element te parnosti i zapamti njegov indeks.
                   Kod provjere za najmanji, koristimo skraceno racunanje
                   logickih izraza za slucaj kad je indeks = -1. */
            if (a[i] % 2 == 0) {    /* Paran. */
                if (i_min_par == -1 || a[i] < a[i_min_par])
                    i_min_par = i;
            }
            else {    /* Neparan. */
                if (i_min_nepar == -1 || a[i] < a[i_min_nepar])
                    i_min_nepar = i;
            }

            /* Ako ima najmanji parni, dovedi ga na poziciju i_par
               i pomakni i_par za jedno mjesto naprijed. */
        if (i_min_par != -1) {
            if (i_min_par != i_par) {
                temp = a[i_par];
                a[i_par] = a[i_min_par];
                a[i_min_par] = temp;
            }
            ++i_par;
        }
            /* Ako ima najmanji neparni, dovedi ga na poziciju i_nepar
               i pomakni i_nepar za jedno mjesto unatrag. */
        if (i_min_nepar != -1) {
            if (i_min_nepar != i_nepar) {
                temp = a[i_nepar];
                a[i_nepar] = a[i_min_nepar];
                a[i_min_nepar] = temp;
            }
            --i_nepar;
        }
    }

    return;
}

    /* Primjer poziva funkcije. */

  preuredi(x, 120);
