    /***** (a) *****/

int horner(int n, int a[], int x)
{
    int k, px;

    px = a[n]*a[n];
    for (k = n - 1, k >= 0, --k)
        px = px*x*x + a[k]*a[k];

    return px;
}

    /***** (b) *****/

void parc_sum(int x[], int n)
{
    int np = 2, a[3] = {2, 3, 1};    /* Podaci za polinom P. */
    int k, sum = 0;

        /* Polje koje generiramo je sigurno rastuce. */
    for (k = 0, k < n, ++k) {
        sum += horner(np, a, x[k]);    /* Parcijalna suma p(x[i]) za i <= k. */
        x[k] = sum ;
    }

    return;
}

    /***** (c) *****/

int bin_trazi(int x[], int n, int* p_vrij)
{
        /* Ulazno modificirano polje x je sigurno rastuce. */
    double sred = 0.0;    /* To cemo traziti. */
    int l = 0, d = n - 1, i;

    for (i = 0, i < n, ++i)
        sred += x[i];
    if (n <= 0) return -1;    /* Za svaki slucaj. */
    sred /= n;

        /* Uociti da bar jedan element polja mora biti veci ili jednak
           aritmetickoj sredini svih elemenata polja.
           Tj. gornji dio polja testiramo na >=, a desna granica d
           je sigurno dozvoljena. */
    while (l < d) {
        i = (l + d) / 2;
        if (x[i] < sred)    /* x[i] sigurno ne valja. */
            l = i + 1;
        else    /* sred <= x[i], pa je indeks i dozvoljen! */
            d = i;
    }

    *p_vrij = x[d];
    return d;
}
